various fixes and additions on desktop
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd ian; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { treetowl || x2 || frodo || tp || demohost; }
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
159 # and you have no idea why.
160 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
161 selinuxenabled && sudo setenforce 0
162 fi
163
164
165 # already ran for pxe installs, but used for vps & updates
166 distro=$(distro-name)
167 case $distro in
168 ubuntu|debian)
169 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
170 ;;
171 *)
172 sudo bash -c ". /a/bin/fai/fai-wrapper &&
173 /a/bin/fai/fai/config/distro-install-common/end"
174 ;;
175 esac
176
177 if linode; then
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.lan $HOSTNAME" | sudo tee -a /etc/hosts
180 fi
181
182
183 if [[ $EUID == 0 ]]; then
184 echo "$0: running as root. exiting now that users are setup"
185 exit 0
186 fi
187
188
189 #### begin link bashrc for root ######
190 for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
191 sudo -i <<EOF
192 PATH="/a/exe:$PATH"
193 lnf $x /root
194 EOF
195 done
196 #### end link bashrc repo for root ######
197 # this needs to be before installing pacserve so we have gpg conf.
198 conflink
199
200 set +x
201 errallow
202 source /etc/profile.d/environment.sh
203 source ~/.bashrc
204 $interactive || errcatch
205 $interactive || set -x
206
207
208 # passwordless sudo
209 tu /etc/sudoers <<'EOF'
210 ian ALL=(ALL) NOPASSWD: ALL
211 Defaults env_keep += SUDOD
212 EOF
213
214
215 # enable magic sysrq keys. debian docs say it is already enabled by default
216 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
217
218
219 if isdebian; then
220 codename=$(debian-codename)
221 if isdebian-stable && has_x; then
222 s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
223 deb http://mozilla.debian.net/ $codename-backports firefox-release
224 deb-src http://mozilla.debian.net/ $codename-backports firefox-release
225 EOF
226 p update
227 # take care of mozilla signing errors in previous command
228 pi pkg-mozilla-archive-keyring
229 p update
230 else
231 :
232 # this would change stable to testing, but I set that up already.
233 # It\'s just a no-op if its already testing.
234 # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
235 p update
236 fi
237 fi
238
239 if isarch; then
240 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
241 sudo pacman -S --noconfirm --needed base-devel jq
242 # pacaur seems to be the best, although it + cower has a few minor bugs,
243 # its design goals seem good, so, going for it.
244
245 aurpi() {
246 for p in "$@"; do
247 tempdir=$(mktemp -d)
248 pushd $tempdir
249 aurex "$p"
250 makepkg -sri --skippgpcheck --noconfirm
251 popd
252 rm -rf $tempdir
253 done
254 }
255 aurpi cower pacaur
256
257 pi pacserve
258
259 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
260 sudo dd of=/etc/pacman.conf if=$x; rm $x
261 sudo systemctl enable pacserve.service
262 sudo systemctl start pacserve.service
263
264 # strange error if just installing trash-cli: "pyalpm requires python",
265 # so I see that it requires python2, and installing that manually fixes it.
266 # I didn't see this on earlier installation, main thing which changed was
267 # pacserve, so not sure if it's related.
268 pi python2
269 fi
270
271 pup
272 pi trash-cli
273
274
275 ###### link files ###########
276 # convenient to just do all file linking in one place
277
278 # if it wasn't set already, we could set hostname here
279 #echo treetowl | s dd of=/etc/hostname
280 #s hostname -F /etc/hostname
281 #HOSTNAME=$(hostname)
282
283
284 s lnf -T /a/bin /b
285
286 if has_p; then
287 lnf -T /p/News ~/News
288 fi
289
290 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
291 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
292
293 rootsshsync
294
295 s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
296
297 # machine is going away
298 # if [[ $HOSTNAME == htpc ]]; then
299 # lnf -T /i/Videos ~/Downloads
300 # fi
301
302 if has_p; then
303 # for dovecot
304 lnf -T /i/k/mboxes ~/mail
305 fi
306
307
308 # basic needed packages
309 case $(distro-name) in
310 debian)
311 if has_x; then
312 if isdebian-stable; then
313 pi firefox/$codename-backports
314 else
315 # for a while, firefox/unstable did not have
316 # dependencies satisfied by testing packages, and i hit
317 # a conflict, it wanted a newer libfontconfig1, but
318 # emacs build-deps wanted an older one. In this case,
319 # I switch to using firefox-esr. note: They seem
320 # to release a new esr version every 9 months or so.
321 pi firefox/unstable
322 s dd of=/etc/apt/preferences.d/firefox <<'EOF'
323 Package: firefox
324 Pin: release a=unstable
325 Pin-Priority: 500
326 EOF
327 fi
328 fi
329 # for hosts which require nonfree drivers
330 # i previously had extra packages listed here linux-image-amd64
331 # firmware-linux-free linux-headers-amd64, but I
332 # don\'t see any reason why. seems to work in testing without.
333 # remove this note if it continues to work.
334 p=firmware-linux-nonfree
335 if apt-cache show $p &>/dev/null; then
336 pi $p
337 fi
338 ;;&
339 ubuntu|debian)
340 if has_x; then
341 if isdebian-stable; then
342 pi xmacro
343 else
344 pi xmacro/unstable # has no unstable deps
345 fi
346 pi gtk-redshift xinput
347 fi
348 ;;&
349 fedora)
350 p -y groupinstall development-tools c-development books admin-tools
351 pi wget man-pages
352 if has_x; then
353 pi redshift-gtk
354 # debian has this package patched to work, upstream is dead
355 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
356 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
357 # http://packages.debian.org/source/sid/xmacro
358 pi patch libXtst-devel
359 cd $(mktemp -d)
360 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
361 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
362 ex *.gz
363 patch -p0 < xmacro_0.3pre-20000911-6.diff
364 cd xmacro-0.3pre-20000911.orig
365 make
366 sleep 1 # not sure why the following command couldn\'t find, so trying this
367 # no make install target
368 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
369 fi
370 ;;&
371 arch)
372 # like apt-cache
373 pi pkgfile
374 s pkgfile --update
375 if has_x; then
376 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
377 pi xorg-server redshift xorg-xinput libxtst xmacro
378
379 # background:
380 # https://aur.archlinux.org/packages/xkbset/#comment-545419
381 cert=$(mktemp)
382 cat >$cert <<'EOF'
383 -----BEGIN CERTIFICATE-----
384 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
385 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
386 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
387 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
388 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
389 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
390 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
391 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
392 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
393 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
394 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
395 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
396 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
397 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
398 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
399 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
400 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
401 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
402 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
403 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
404 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
405 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
406 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
407 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
408 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
409 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
410 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
411 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
412 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
413 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
414 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
415 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
416 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
417 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
418 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
419 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
420 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
421 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
422 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
423 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
424 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
425 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
426 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
427 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
428 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
429 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
430 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
431 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
432 lzGQzw==
433 -----END CERTIFICATE-----
434 -----BEGIN CERTIFICATE-----
435 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
436 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
437 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
438 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
439 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
440 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
441 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
442 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
443 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
444 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
445 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
446 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
447 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
448 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
449 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
450 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
451 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
452 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
453 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
454 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
455 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
456 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
457 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
458 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
459 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
460 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
461 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
462 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
463 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
464 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
465 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
466 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
467 -----END CERTIFICATE-----
468 -----BEGIN CERTIFICATE-----
469 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
470 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
471 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
472 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
473 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
474 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
475 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
476 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
477 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
478 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
479 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
480 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
481 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
482 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
483 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
484 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
485 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
486 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
487 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
488 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
489 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
490 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
491 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
492 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
493 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
494 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
495 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
496 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
497 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
498 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
499 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
500 jjxDah2nGN59PRbxYvnKkKj9
501 -----END CERTIFICATE-----
502 EOF
503 cat /etc/ssl/certs/ca-certificates.crt >> $cert
504 CURL_CA_BUNDLE=$cert pi xkbset
505 fi
506
507 ;;&
508 ubuntu|debian|fedora)
509 if has_x; then
510 if isdebian-stable; then
511 pi xkbset
512 else
513 # xkbset was in testing for quite a while, dunno
514 # why it\'s not anymore. Sometime I should check and
515 # see if it\'s back in testing, but the unstable package
516 # doesn\'t upgrade anything form testing, and it\'s tiny
517 # so I\'m not bothering to automate it.
518 pi xkbset/unstable
519 fi
520 fi
521 ;;&
522 esac
523
524 if has_x; then
525 pi xbindkeys
526 fi
527 pi cryptsetup lvm2
528 # enables trim for volume delete, other rare commands.
529 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
530
531 if encrypted; then
532 if isdeb; then
533 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
534 fi
535 # does weekly trim
536 sudo systemctl enable fstrim.timer
537 fi
538
539 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
540 s mkdir -p "${dirs[@]}"
541 s chown ian:ian "${dirs[@]}"
542
543
544 tu /etc/fstab <<'EOF'
545 /i/w /w none bind,noauto 0 0
546 /i/k /k none bind,noauto 0 0
547 EOF
548
549
550 if ! mountpoint /kr; then
551 s mkdir -p /kr
552 s chown ian:traci /kr
553 fi
554
555 if home_network; then
556 if [[ $HOSTNAME == treetowl ]]; then
557 tu /etc/fstab <<'EOF'
558 /k /kr none bind,noauto 0 0
559 EOF
560 else
561 tu /etc/fstab <<'EOF'
562 treetowl:/k /kr nfs noauto 0 0
563 EOF
564 fi
565 fi
566
567 s mkdir -p /q /i/{w,k}
568 for dir in /{i,w,k}; do
569 if mountpoint $dir; then continue; fi # already mounted
570 s mkdir -p $dir
571 s chown ian:ian $dir
572 done
573
574 # not needed for all hosts, but rather just keep it uniform
575 s mkdir -p /mnt/iroot
576
577 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
578 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
579 # based on 3 of those, it creates .device units for /dev/mapper/dev...
580 # then waits endlessly for them on bootup, after the /dev/mapper disks
581 # have already been created and exist. todo: create a simple repro
582 # for this in a vm and report it upstream.
583 if has_btrfs || home_network; then
584 pi nfs-common
585 s dd of=/root/imount <<'EOF'
586 #!/bin/bash
587 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
588 set -eE -o pipefail
589 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
590 for dir in /i /mnt/iroot /k /kr /w; do
591 if ! mountpoint $dir &>/dev/null && \
592 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
593 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
594 mount $dir || echo "warning: failed to mount nfs on $dir"
595 else
596 mount $dir
597 fi
598 fi
599 done
600 EOF
601 s chmod +x /root/imount
602
603 s dd of=/etc/systemd/system/imount.service <<'EOF'
604 [Unit]
605 Description=Mount /i and related mountpoints
606 RequiredBy=syncthing@ian.service
607 Before=syncthing@ian.service
608
609 [Service]
610 Type=oneshot
611 ExecStart=/root/imount
612
613 [Install]
614 # note /kr needs networking, this target is the simplest way to
615 # time it when the network should be up, but not do something
616 # dumb like delay startup until the network is up. It happens
617 # at some time after network.target
618 WantedBy=multi-user.target
619 EOF
620 sudo systemctl daemon-reload # needed if the file was already there
621 sudo systemctl enable imount.service
622 sudo systemctl start imount.service
623 fi
624
625 dir=/nocow
626 if has_btrfs; then
627 if ! mountpoint $dir; then
628 subvol=/mnt/root/nocow
629 if [[ ! -e $subvol ]]; then
630 s btrfs subvolume create $subvol
631 s chown root:1000 $subvol
632 s chattr +C $subvol
633 fi
634
635 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
636 tu /etc/fstab <<EOF
637 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
638 EOF
639 s mkdir -p $dir
640 s chown ian:ian $dir
641 s mount $dir
642 fi
643 else
644 sudo mkdir -p $dir
645 fi
646
647 # ssh and probably some other things care about parent directory
648 # ownership, and ssh doesn\'t allow any group writable parent
649 # directories, so we are forced to use a directory structure similar
650 # to home directories
651 s chown root:ian /q
652 s chmod 755 /q
653
654
655 # it comes with stretch and arch, but not jessie.
656 # propogate /etc/udev/hwdb.d
657 if which systemd-hwdb; then
658 s systemd-hwdb update
659 ser restart systemd-udev-trigger
660 fi
661
662
663 if isdeb; then
664 # I\'ve had problems with postfix on debian:
665 # on stretch, a startup ordering issue caused all mail to fail.
666 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
667 # exim4 is default on debian, so I assume it would
668 # be packaged better to avoid these types of things.
669 # I haven\'t gotten around to getting a non-debian exim
670 # setup.
671 mail-setup exim4
672 else
673 mail-setup postfix
674 fi
675
676 if isubuntu; then
677 # disable crash report annoying crap
678 s dd of=/etc/default/apport <<<'enabled=0'
679 fi
680
681 # fai sets this an old way that doesn't work for stretch.
682 # no harm in setting it universally here.
683 # using debconf-set-selection, the area gets reset to ETC
684 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
685 # so we are using expect :(
686 # I got a random error when running this, so I added a sleep
687 # rather than trying to write a whole detect and wait loop.
688 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
689 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
690 sleep 1
691 s apt-get -y install --no-install-recommends expect
692 s expect <<EOF
693 set force_conservative 0
694 spawn dpkg-reconfigure tzdata -freadline
695 expect -nocase timeout {exit 1} "Geographic area:"
696 send "12\r"
697 expect -nocase timeout {exit 1} "Time zone:"
698 send "11\r"
699 expect eof
700 exit
701 EOF
702
703
704 if has_x; then
705 if isarch; then
706 # install so it's build dependencies don't get removed.
707
708 # emacs git build is currently broken
709 if false; then
710 x=$(mktemp -d)
711 pushd $x
712 aurex emacs-git
713 makepkg -si --noconfirm
714 popd
715 rm -rf $x
716 else
717 pi emacs
718 fi
719 pi hunspell hunspell-en
720 else
721 if $recompile; then
722 /a/bin/buildscripts/emacs
723 else
724 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
725 fi
726 fi
727
728 # todo, figure this out for arch if we ever try out gnome.
729 if ! isarch; then
730 # install for multiple display managers in case we use one
731 if isdeb; then
732 dir=/etc/gdm3
733 elif isfedora; then
734 # fedora didn\'t have the 3.
735 dir=/etc/gdm
736 fi
737 s mkdir -p $dir/PostLogin
738 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
739 s mkdir /etc/lightdm/lightdm.conf.d
740 s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
741 [SeatDefaults]
742 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
743 EOF
744 fi
745
746
747 pi ghc sakura
748 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
749
750 # use the package manger version to install the cabal version
751 pi cabal-install
752 cabal update
753 PATH="$PATH:$HOME/.cabal/bin"
754
755 # todo, on older ubuntu I used cabal xmonad + xfce,
756 # see /a/bin/old-unused/xmonad-cabal.sh
757
758 # trying out the distros versions newer distros
759 pi xmonad
760 if isarch; then
761 # for displaying error messages.
762 # optional dependency in arch, standard elsewhere.
763 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
764
765 # https://wiki.archlinux.org/index.php/Xinitrc
766 for homedir in /home/*; do
767 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
768 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
769 tee -a $homedir/.xinitrc <<'EOF'
770 /a/bin/desktop-20-autostart.sh
771 xsetroot -cursor_name left_ptr
772 exec xmonad
773 EOF
774 done
775 else
776 pi suckless-tools
777 fi
778 pi dmenu
779
780 if isdeb && (tp || x2); then
781 pi task-laptop
782 fi
783 fi
784
785 # the first pup command can kill off our /etc/ mod, so rerun this
786 /a/exe/ssh-emacs-setup
787 echo "$0: $(date): ending now"